A7 {IFORTRAŇvZvOW

A7.1 ʒu̐ݒ

A7.1.1 2n (SUBROUTINE INIPOSIT)

00010 C*********************************************************************  
00020 C   THIS SUBROUTINE IS FOR SETTING INITIAL POSITIONS OF PARTICLES    *
00030 C   AT CLOSED-PACKED LATTICE POINTS FOR TWO-DIMENSIONAL SYSTEM.      *
00040 C     0<RX(I)<XL  ,  0<RY(I)<YL                                      *   
00050 C*********************************************************************
00060 C**** SUB INIPOSIT *****                                                
00070       SUBROUTINE INIPOSIT( N, NDENS, RCOFF, NP )                        
00080 C                                                                       
00090       IMPLICIT REAL*8( A-H , O-Z )                                      
00100 C                                                                       
00110       COMMON /BLOCK1/  RX , RY                                          
00120       COMMON /BLOCK6/  XL , YL                                          
00130 C                                                                       
00140       PARAMETER( NN=1000 )                                              
00150 C                                                                       
00160       REAL*8  RX(NN), RY(NN), XL, YL, NDENS, RCOFF                      
00170       INTEGER N     , NP                                                
00180 C                                                                       
00190       REAL*8  RXI, RYI, RX0, RY0 ,  A , AX , AY , C1      
00200       INTEGER KX , KY , K  , P                                          
00210 C                                                                       
00220       A  =  ( (2.D0/3.D0**0.5)/NDENS )**0.5                             
00230       P  = IDNINT( DSQRT(DBLE(N/4)) )                                   
00240       XL = 3.D0**0.5*A*DBLE(P)                                          
00250       YL = 2.D0*A*DBLE(P)                                               
00260       IF( (XL/2.D0.LE.RCOFF) .OR. (YL/2.D0.LE.RCOFF) )THEN              
00270         WRITE(NP,*)                                                     
00280         WRITE(NP,*) '++++ SIMULATION BOX IS TOO SMALL ++++'             
00290         WRITE(NP,*)                                                     
00300         RETURN                                                          
00310       END IF                                                            
00320 C                                                                       
00330       AX   =  3.D0**0.5*A                                               
00340       AY   =  2.D0*A                                                    
00350       KX   =  P                                                         
00360       KY   =  P                                                         
00370       C1   = 0.01D0                                                     
00380 C                                        --- SET INITIAL POSITIONS ---  
00390       K    =  0                                                         
00400 C                                                                       
00410       DO 100 IFACE=1,4                                                  
00420         IF( IFACE.EQ.1 ) THEN                                           
00430           RX0 = C1                                                      
00440           RY0 = C1                                                      
00450         ELSE IF( IFACE.EQ.2 ) THEN                                      
00460           RX0 = C1                                                      
00470           RY0 = A + C1                                                  
00480         ELSE IF( IFACE.EQ.3 ) THEN                                      
00490           RX0 = AX/2.D0 + C1                                            
00500           RY0 = A/2.D0  + C1                                            
00510         ELSE IF( IFACE.EQ.4 ) THEN                                      
00520           RX0 = AX/2.D0 + C1                                            
00530           RY0 = A*3.D0/2.D0 + C1                                        
00540         END IF                                                          
00550         DO 40 J=0,KY-1                                                  
00560           RYI = DBLE(J)*AY + RY0                                        
00570           IF( RYI .GE. YL )    GOTO 40                                  
00580           DO 30 I=0,KX-1                                                
00590             RXI = DBLE(I)*AX + RX0                                      
00600             IF( RXI .GE. XL )  GOTO 30                                  
00610 C                                                                       
00620             K=K+1                                                       
00630             RX(K)   =  RXI                                              
00640             RY(K)   =  RYI                                              
00650    30     CONTINUE                                                      
00660    40   CONTINUE                                                        
00670   100 CONTINUE                                                          
00680       RETURN  
00690       END


A7.1.2 3n (SUBROUTINE INIPOSIT)

00010 C*********************************************************************  
00020 C   THIS SUBROUTINE IS FOR SETTING INITIAL POSITIONS OF PARTICLES    *
00030 C   AT CLOSED-PACKED LATTICE POINTS FOR THREE-DIMENSIONAL SYSTEM.    *
00040 C     0<RX(I)<L  ,  0<RY(I)<L  ,  0<RZ(I)<L                          * 
00050 C*********************************************************************
00060 C**** SUB INIPOSIT *****                                                
00070       SUBROUTINE INIPOSIT( N , NDENS , L )                              
00080 C                                                                       
00090       IMPLICIT REAL*8( A-H , O-Z )                                      
00100 C                                                                       
00110       COMMON /BLOCK1/ RX , RY , RZ                                      
00120 C                                                                       
00130       PARAMETER( NN=2050 , PI=3.141592653589793D0 )                     
00140 C                                                                       
00150       REAL*8  RX(NN), RY(NN), RZ(NN), NDENS , L                         
00160       INTEGER N                                                         
00170 C                                                                       
00180       REAL*8  RXI, RYI, RZI, RX0, RY0, RZ0 , C0   
00190       INTEGER Q  , K  , IX , IY , IZ  
00200 C 
00210       C0 =  ( 4.D0/NDENS )**(1./3.)                                     
00220       Q  =  IDNINT( DBLE(N/4)**(1./3.) )                                
00230       L  =  C0*DBLE(Q)                                                  
00240 C                                        --- SET INITIAL POSITIONS ---  
00250       K  =  0                                                           
00260 C                                                                       
00270       DO 100 IFACE=1,4                                                  
00280 C                                                                       
00290         IF( IFACE.EQ.1 ) THEN                                           
00300           RX0 = 0.0001D0                                                
00310           RY0 = 0.0001D0                                                
00320           RZ0 = 0.0001D0                                                
00330         ELSE IF( IFACE.EQ.2 ) THEN                                      
00340           RX0 = C0/2.D0                                                 
00350           RY0 = C0/2.D0                                                 
00360           RZ0 = 0.0001D0                                                
00370         ELSE IF( IFACE.EQ.3 ) THEN                                      
00380           RX0 = C0/2.D0                                                 
00390           RY0 = 0.0001D0                                                
00400           RZ0 = C0/2.D0                                                 
00410         ELSE IF( IFACE.EQ.4 ) THEN                                      
00420           RX0 = 0.0001D0                                                
00430           RY0 = C0/2.D0                                                 
00440           RZ0 = C0/2.D0                                                 
00450         END IF                                                          
00460 C                                                                       
00470         DO 50 IZ=0,Q-1                                                  
00480           RZI = DBLE(IZ)*C0 + RZ0                                       
00490           IF( RZI .GE. L )        GOTO 50                               
00500           DO 40 IY=0,Q-1                                                
00510             RYI = DBLE(IY)*C0 + RY0                                     
00520             IF( RYI .GE. L )      GOTO 40                               
00530             DO 30 IX=0,Q-1                                              
00540               RXI = DBLE(IX)*C0 + RX0                                   
00550               IF( RXI .GE. L )    GOTO 30                               
00560 C                                                                       
00570               K=K+1                                                     
00580               RX(K)   =  RXI                                            
00590               RY(K)   =  RYI                                            
00600               RZ(K)   =  RZI                                            
00610    30       CONTINUE                                                    
00620    40     CONTINUE                                                      
00630    50   CONTINUE                                                        
00640   100 CONTINUE                                                          
00650 C                                                                       
00660       N = K                                                             
00670       RETURN  
00680       END     


A7.2  (SUBROUTINE RANCAL)

00010 C*********************************************************************  
00020 C   THIS SUBROUTINE IS FOR GENERATING UNIFORM RANDOM NUMBERS         *
00030 C   (SINGLE PRECISION).                                              *
00040 C      N      : NUMBER OF RANDOM NUMBERS TO GENERATE                 *
00050 C      IX     : INITIAL VALUE OF RANDOM NUMBERS (POSITIVE INTEGER)   *
00060 C             : LAST GENERATED VALUE IS KEPT                         *
00070 C      X(N)   : GENERATED RANDOM NUMBERS (0<X(N)<1)                  * 
00080 C*********************************************************************
00090 C**** SUB RANCAL ****                                               
00100       SUBROUTINE RANCAL( N, IX, X )   
00110 C                                                                   
00120       DIMENSION  X(N)                                               
00130       DATA INTEGMX/2147483647/                                      
00140       DATA INTEGST,INTEG/584287,48828125/                           
00150 C                                                                   
00160       AINTEGMX = REAL( INTEGMX )                    
00170 C                                                                   
00180       IF ( IX.LT.0 ) PAUSE  
00190       IF ( IX.EQ.0 ) IX = INTEGST                               
00200       DO 30 I=1,N                                                   
00210          IX = IX*INTEG                                              
00220          IF (IX) 10, 20, 20                                    
00230    10    IX   = (IX+INTEGMX)+1                                  
00240    20    X(I) = REAL(IX)/AINTEGMX                             
00250    30 CONTINUE                                                      
00260       RETURN  
00270       END     


A7.3 ubN@(2n)

00010 C*********************************************************************
00020 C*  THIS PROGRAM IS PART OF THE MAIN PROGRAM WHICH IS FOR            *
00030 C*  INTRODUCING THE CELL INDEX METHOD FOR TWO-DIMENSIONAL SYSTEM.    *
00040 C*********************************************************************
00050 C     GRPY(I),GRPX(I)   : GROUP TO WHICH PARTICLE I BELONGS            
00060 C     P           : NUMBER OF CUT-OFF CELLS IN EACH DIRECTION          
00070 C     TMX(GRP)    : TOTAL NUMBER OF PARTICLES BELONGING TO GROUP(GRP)  
00080 C     TABLE(*,GRP): NAME OF PARTICLE BELONGING TO GROUP(GRP)           
00090 C     GRPLX(P)    : IS USED TO DETERMINE THE CELL TO WHICH           
00100 C                   PARTICLES BELONG                             
00110 C     0<RX(I)<L  ,  0<RY(I)<L                                         
00120 C---------------------------------------------------------------------  
00130 C                                                                       
00140       IMPLICIT REAL*8 (A-H,O-Z)                                         
00150 C                                                                       
00160       COMMON /BLOCK1/  RX   , RY                                        
00170       COMMON /BLOCK3/  GRPX , GRPY                                      
00180       COMMON /BLOCK5/  TMX  , TABLE                                     
00190       COMMON /BLOCK6/  P    , GRPLX                                     
00200 C                                 --- NN : NUM. OF PARTICLES       ---  
00210 C                                 --- PP : NUM. OF CUT-OFF CELLS   ---  
00220       INTEGER  NN , PP , PP2 , TT                          
00230       PARAMETER( NN=1000 , PP=15 , PP2=225 , TT=500 )          
00240 C                                                                       
00250       REAL*8   RX(NN) , RY(NN) , GRPLX(PP) , NDENS  , L    
00260       INTEGER  GRPX(NN) , GRPY(NN) , TMX(PP2) , TABLE(TT,PP2) , N , P 
00270                  .
00280                  .
00290                  .
00300 C     ----------------------------------------------------------------  
00310 C     -------------------   SET CELL INDEX METHOD   ------------------  
00320 C     ----------------------------------------------------------------  
00330 C                                               --- MAKE P*P CELLS ---  
00340       CALL CELLSET( N , NDENS , L , RCOFF )                            
00350 C                                        --- SET INITIAL POSITIONS ---
00360       CALL INIPOSIT( N , NDENS , RCOFF , NP )                          
00370 C                                       --- CELL NAME OF PARTICLES ---
00380       CALL GROUP( N )                                                   
00390 C                                  --- PARTICLE NAMES OF EACH CELL ---  
00400       CALL TABLECAL( N , P )                                            
00410                  .
00420                  .
00430                  .
00440       STOP
00450       END
00460 C*********************************************************************  
00470 C   THIS SUBROUTINE IS FOR DISTRIBUTING A MAIN CELL INTO             *
00480 C   MANY SUB-CELLS.                                                  *
00490 C*********************************************************************
00500 C**** SUB CELLSET ****                                                 
00510       SUBROUTINE CELLSET( N ,NDENS , L , RCOFF )                       
00520 C                                                                       
00530       IMPLICIT REAL*8 (A-H,O-Z)                                         
00540 C                                                                       
00550       COMMON /BLOCK6/  P   , GRPLX                                      
00560 C                                                                       
00570       INTEGER  PP                                                       
00580       PARAMETER( PP=15 )                                                
00590 C                                                                       
00600       INTEGER  P                                                        
00610       REAL*8   GRPLX(PP) , NDENS , L , C0                               
00620 C                                                                       
00630       L =  DSQRT( DBLE(N)/NDENS )                                       
00640       P = INT(L/RCOFF)                                                  
00650       IF(P .LE. 2) PAUSE                                                
00660 C                                                                       
00670       C0 = L/DBLE(P)                                                    
00680       DO 10 I=1,P                                                       
00690         GRPLX(I) = C0*DBLE(I)                                           
00700    10 CONTINUE                                                          
00710       RETURN   
00720       END      
00730 C*********************************************************************  
00740 C   THIS SUBROUTINE IS FOR CHECKING THE SUB-CELL TO WHICH EACH       *
00750 C   PARTICLE BELONGS.                                                *
00760 C*********************************************************************
00770 C**** SUB GROUP *****                                                   
00780       SUBROUTINE GROUP( N )                                             
00790 C                                                                       
00800       IMPLICIT REAL*8 (A-H,O-Z)                                         
00810 C                                                                       
00820       COMMON /BLOCK1/  RX , RY                                          
00830       COMMON /BLOCK3/  GRPX, GRPY                                       
00840       COMMON /BLOCK6/  P   , GRPLX                                      
00850 C                                                                       
00860       INTEGER  NN , PP                                                  
00870       PARAMETER( NN=1000 , PP=15 )                                      
00880 C                                                                       
00890       INTEGER  GRPX(NN) , GRPY(NN) , N      , P                         
00900       REAL*8   RX(NN)   , RY(NN)   , GRPLX(PP)                          
00910 C                                                                       
00920       DO 30 I=1,N                                                       
00930 C                                                  ----- X AXIS -----   
00940         DO 10 J=1,P                                                     
00950           IF( GRPLX(J) .GT. RX(I) ) THEN                                
00960             GRPX(I) = J                                                 
00970             GOTO 15                                                     
00980           END IF                                                        
00990    10   CONTINUE                                                        
01000         GRPX(I) = P                                                     
01010 C                                                  ----- Y AXIS -----   
01020    15   DO 20 J=1,P                                                     
01030           IF( GRPLX(J) .GT. RY(I) ) THEN                                
01040             GRPY(I) = J                                                 
01050             GOTO 30                                                     
01060           END IF                                                        
01070    20   CONTINUE                                                        
01080         GRPY(I) = P                                                     
01090 C                                                                       
01100    30 CONTINUE                                                          
01110       RETURN   
01120       END      
01130 C*********************************************************************  
01140 C   THIS SUBROUTINE IS FOR CHECKING THE PARTICLE NAMES WHICH EACH    *
01150 C   SUB-CELL HAS.                                                    *
01160 C*********************************************************************
01170 C**** SUB TABLECAL *****                                                
01180       SUBROUTINE TABLECAL( N , P )                                      
01190 C                                                                       
01200       IMPLICIT REAL*8 (A-H,O-Z)                                         
01210 C                                                                       
01220       COMMON /BLOCK3/  GRPX, GRPY                                       
01230       COMMON /BLOCK5/  TMX , TABLE                                      
01240 C                                                                       
01250       INTEGER  NN , PP2 , TT                                            
01260       PARAMETER( NN=1000 , PP2=225 , TT=500  )                          
01270 C                                                                       
01280       INTEGER  GRPX(NN) , GRPY(NN) , TMX(PP2) , TABLE(TT,PP2) 
01290       INTEGER  N   , P  , GX  , GY , GP     
01300 C                                                                       
01310       DO 10 GY=1,P                                                      
01320       DO 10 GX=1,P                                                      
01330         GP = GX + (GY-1)*P                                              
01340         TMX(GP)     = 0                                                 
01350         TABLE(1,GP) = 0                                                 
01360    10 CONTINUE                                                          
01370 C                                                                       
01380       DO 20 I=1,N                                                       
01390         GX = GRPX(I)                                                    
01400         GY = GRPY(I)                                                    
01410         GP = GX + (GY-1)*P                                              
01420         TMX(GP) = TMX(GP) + 1                                           
01430         TABLE( TMX(GP),GP ) = I                                         
01440    20 CONTINUE                                                          
01450       RETURN   
01460       END      


A7.4 ͂ёݍp̃GlM[̌vZ

A7.4.1 ݍp̃GlM[̌vZ (SUBROUTINE ENECAL)

00010 C*********************************************************************  
00020 C   THIS SUBROUTINE IS FOR CALCULATING ENERGIES BETWEEN PARTICLES    *
00030 C   FOR THREE-DIMENSIONAL LENNARD-JONES SYSTEM.                      *  
00040 C      ETOT(I)     : ENERGY OF PARTICLE I                            *  
00050 C      E(*,I)      : INTERACTION ENERGY OF PARTICLE I WITH THE OTHERS*  
00060 C      ETMX(I)     : TOTAL NUMBER OF PARTICLES INTERACTING WITH I    *  
00070 C      ETABLE(*,I) : NAME OF PARTICLES INTERACTING WITH I            * 
00080 C      RCOFF2 = RCOFF**2                                             *
00090 C*********************************************************************
00100 C**** SUB ENECAL *****                                                  
00110       SUBROUTINE ENECAL( N , RCOFF2 )                                   
00120 C                                                                       
00130       IMPLICIT REAL*8 (A-H,O-Z)                                         
00140 C                                                                       
00150       COMMON /BLOCK1/  RX , RY , RZ                                     
00160       COMMON /BLOCK4/  E    , ETOT , ETMX , ETABLE                      
00170       COMMON /BLOCK8/  NDENS, TEMP , RCOFF ,  L                         
00180 C                                                                       
00190       INTEGER  NN , TT                                                  
00200       PARAMETER( NN=2050 , TT=600  )                                    
00210 C                                                                       
00220       INTEGER  N  ,  ETMX(NN) , ETABLE(TT,NN)       
00230       REAL*8   RX(NN), RY(NN), RZ(NN), E(TT,NN), ETOT(NN), NDENS, L  
00240 C
00250       REAL*8   RXIJ , RYIJ , RZIJ , RIJSQ , L2                          
00260 C                                                                       
00270       L2 = L/2.D0                                                       
00280       DO 5 I=1,N                                                        
00290         ETMX(I) = 0                                                     
00300         ETABLE(1,I) = 0                                                 
00310         DO 3 J=1,TT                                                     
00320           E(J,I) = 0.D0                                                 
00330     3   CONTINUE                                                        
00340     5 CONTINUE                                                          
00350 C                                                                       
00360       DO 100 I=1,N                                                      
00370 C                                                                       
00380         ETOT(I)= 0.D0                                                   
00390 C                                                                       
00400 C                                            ---- CALCULATE ENERGY ---  
00410             DO 40 J=1,N                                                 
00420               IF( J .EQ. I )          GOTO 40                           
00430 C                                                                       
00440               RXIJ = RX(J) - RX(I)                                      
00450               IF( RXIJ .GE.  L2 ) RXIJ = RXIJ - L                       
00460               IF( RXIJ .LT. -L2 ) RXIJ = RXIJ + L                       
00470               IF( DABS(RXIJ) .GE. RCOFF ) GOTO 40                       
00480               RYIJ = RY(J) - RY(I)                                      
00490               IF( RYIJ .GE.  L2 ) RYIJ = RYIJ - L                       
00500               IF( RYIJ .LT. -L2 ) RYIJ = RYIJ + L                       
00510               IF( DABS(RYIJ) .GE. RCOFF ) GOTO 40                       
00520               RZIJ = RZ(J) - RZ(I)                                      
00530               IF( RZIJ .GE.  L2 ) RZIJ = RZIJ - L                       
00540               IF( RZIJ .LT. -L2 ) RZIJ = RZIJ + L                       
00550               IF( DABS(RZIJ) .GE. RCOFF ) GOTO 40                       
00560 C                                                                       
00570               RIJSQ= RXIJ**2 + RYIJ**2 + RZIJ**2                        
00580               IF( RIJSQ .GE. RCOFF2 )     GOTO 40                       
00590 C                                                                       
00600               SR2  = 1.D0/RIJSQ                                         
00610               SR6  = SR2*SR2*SR2                                        
00620               EIJ  = SR6*( SR6-1.D0 )                                   
00630 C                                                                       
00640               ETOT(I) = ETOT(I) + EIJ*4.D0                              
00650 C                                                                       
00660               ETMX(I) = ETMX(I) + 1                                     
00670               ETABLE(ETMX(I),I) = J                                     
00680               E(ETMX(I),I) = EIJ*4.D0                                   
00690    40       CONTINUE                                                    
00700 C                                                                       
00710   100 CONTINUE                                                          
00720       RETURN  
00730       END    


A7.4.2 ͂̌vZ (SUBROUTINE FORCECAL)

00010 C*********************************************************************  
00020 C   THIS SUBROUTINE IS FOR CALCULATING FORCES BETWEEN PARTICLES      *
00030 C   FOR THREE-DIMENSIONAL LENNARD-JONES SYSTEM.                      *  
00040 C      RCOFF2 = RCOFF**2                                             * 
00050 C*********************************************************************
00060 C**** SUB FORCECAL *****                                              
00070       SUBROUTINE FORCECAL( N, RCOFF, RCOFF2, RX, RY, RZ, FX, FY, FZ )   
00080 C                                                                       
00090       IMPLICIT REAL*8( A-H , O-Z )                                      
00100 C                                                                       
00110       COMMON /BLOCK8/ XL    , YL     , ZL                               
00120 C                                                                       
00130       PARAMETER( NN=2050 )                                              
00140 C                                                                       
00150       INTEGER  N                                                        
00160       REAL*8   RX(NN)  , RY(NN)  , RZ(NN) , FX(NN) , FY(NN) , FZ(NN)    
00170 C                                                                       
00180       REAL*8   RXI  , RYI  , RZI  , RXIJ , RYIJ , RZIJ , RIJSQ          
00190       REAL*8   FXI  , FYI  , FZI  , FXIJ , FYIJ , FZIJ , FIJ            
00200       REAL*8   SR2  , SR6  , SR12                                       
00210 C                                                                       
00220       DO 10 I=1,N                                                       
00230         FX(I) = 0.D0                                                    
00240         FY(I) = 0.D0                                                    
00250         FZ(I) = 0.D0                                                    
00260    10 CONTINUE                                                          
00270 C                                                                       
00280       DO 100 I=1,N-1                                                    
00290 C                                                                       
00300         RXI = RX(I)                                                     
00310         RYI = RY(I)                                                     
00320         RZI = RZ(I)                                                     
00330         FXI = FX(I)                                                     
00340         FYI = FY(I)                                                     
00350         FZI = FZ(I)                                                     
00360 C                                                                       
00370         DO 50 J=I+1,N                                                   
00380 C                                                                       
00390           RXIJ = RXI  - RX(J)                                           
00400           RXIJ = RXIJ - DNINT(RXIJ/XL)*XL                               
00410           IF( DABS(RXIJ) .GE. RCOFF )      GOTO 50                      
00420           RYIJ = RYI  - RY(J)                                           
00430           RYIJ = RYIJ - DNINT(RYIJ/YL)*YL                               
00440           IF( DABS(RYIJ) .GE. RCOFF )      GOTO 50                      
00450           RZIJ = RZI  - RZ(J)                                           
00460           RZIJ = RZIJ - DNINT(RZIJ/ZL)*ZL                               
00470           IF( DABS(RZIJ) .GE. RCOFF )      GOTO 50                      
00480 C                                                                       
00490           RIJSQ= RXIJ*RXIJ + RYIJ*RYIJ + RZIJ*RZIJ                      
00500           IF( RIJSQ .GE. RCOFF2 )          GOTO 50                      
00510 C                                                                       
00520           SR2  = 1.D0/RIJSQ                                             
00530           SR6  = SR2*SR2*SR2                                            
00540           SR12 = SR6*SR6                                                
00550           FIJ  = ( 2.D0*SR12 - SR6 )/RIJSQ                              
00560           FXIJ = FIJ*RXIJ                                               
00570           FYIJ = FIJ*RYIJ                                               
00580           FZIJ = FIJ*RZIJ                                               
00590           FXI  = FXI  + FXIJ                                            
00600           FYI  = FYI  + FYIJ                                            
00610           FZI  = FZI  + FZIJ                                            
00620 C                                                                       
00630           FX(J) = FX(J) - FXIJ                                          
00640           FY(J) = FY(J) - FYIJ                                          
00650           FZ(J) = FZ(J) - FZIJ                                          
00660 C                                                                       
00670    50   CONTINUE                                                        
00680 C                                                                       
00690         FX(I) = FXI                                                     
00700         FY(I) = FYI                                                     
00710         FZ(I) = FZI                                                     
00720 C                                                                       
00730   100 CONTINUE                                                          
00740 C                                                                       
00750       DO 120 I=1,N                                                      
00760         FX(I) = FX(I)*24.D0                                             
00770         FY(I) = FY(I)*24.D0                                             
00780         FZ(I) = FZ(I)*24.D0                                             
00790   120 CONTINUE                                                          
00800       RETURN  
00810       END     


A7.5 eJEASYɂ铮az֐̌vZvO
     (MCRADIA1.FORT)

00010 C*********************************************************************  
00020 C*                                                                   *  
00030 C*              MCRADIA1.FORT                                        *  
00040 C*                                                                   *
00050 C*     ---------------------------------------------------------     *
00060 C*     -  NVT MONTE CARLO SIMULATION OF RADIAL DISTRIBUTION    -     *  
00070 C*     -  FUNCTIONS FOR THREE-DIMENSIONAL LENNARD-JONES SYSTEM.-     *
00080 C*     ---------------------------------------------------------     *  
00090 C*              1. CALCULATION OF RADIAL DISTRIBUTION FUNCTIONS      *  
00100 C*              2. NOT USING THE CELL INDEX METHOD                   *  
00110 C*                                                                   *  
00120 C*    COMMAND PROC. (FOR HITAC-VOS3)                                 *   
00130 C*      10 ALLOC DD(FT09F001) DS(@AA1.DATA) REN REU : PROCESS        *  
00140 C*      20 ALLOC DD(FT06F001) DS(*)                                  *  
00150 C*      30 ALLOC DD(FT10F001) DS(AA11.DATA) REN REU : PARA.,MEAN ENE *  
00160 C*      40 ALLOC DD(FT11F001) DS(AA21.DATA) REN REU : RADIAL FUNC.   *  
00170 C*      50 ALLOC DD(FT19F001) DS(AA091.DATA) SHR REU: POSITION(OLD)  *  
00180 C*      60 ALLOC DD(FT21F001) DS(AA001.DATA) REN REU: POSITION       *  
00190 C*      70 ALLOC DD(FT22F001) DS(AA011.DATA) REN REU                 *  
00200 C*      80 RUN MCRADIA1.FORT                                         *  
00210 C*      90 FREE ALL                                                  *  
00220 C*      95 END                                                       *  
00230 C*                                                                   *  
00240 C*                                     VER.1  BY A.SATOH , '95 3/2   *  
00250 C*********************************************************************  
00260 C     ETOT(I)     : ENERGY OF PARTICLE I                  
00270 C     E(*,I)      : INTERACTION ENERGY OF PARTICLE I WITH THE OTHERS   
00280 C     ETMX(I)     : TOTAL NUMBER OF PARTICLES INTERACTING WITH I      
00290 C     ETABLE(*,I) : NAME OF PARTICLES INTERACTING WITH I              
00300 C     MEANENE(**) : MEAN ENERGY OF SYSTEM AT EACH MC STEP        
00310 C     DLTA    : MAXIMUM MOVEMENT DISTANCE FOR USUAL MC METHOD          
00320 C     DR      : RADIAL INTERVAL FOR CALCULATING RAD.DIST.FUNC.         
00330 C     RMX     : MAXIMUM RADIAL                                         
00340 C     R0(*)   : IS USED TO DETERMINE THE UNIT TO WHICH EACH PARTICLE  
00350 C               BELONGS ( 1=< * =< NR0MX )                     
00360 C     R(*)    : REPRESENTATIVE POINT FOR EACH UNIT FOR RAD.DIST.FUNC.
00370 C               ( 1=< * =< NRMX )                                      
00380 C     RADIAL  : RAD.DIST.FUNC.
00390 C     SUMRAD  : SUMMATION OF RAD.DIST.FUNC.
00400 C     0<RX(I)<L  ,  0<RY(I)<L  ,  0<RZ(I)<L
00410 C---------------------------------------------------------------------  
00420       IMPLICIT REAL*8 (A-H,O-Z)                                         
00430 C                                                                       
00440       COMMON /BLOCK1/  RX   , RY   , RZ                                 
00450       COMMON /BLOCK4/  E    , ETOT , ETMX , ETABLE                      
00460       COMMON /BLOCK7/  NRAN , RAN  , IX                                 
00470       COMMON /BLOCK8/  NDENS, TEMP , RCOFF,  L                          
00480       COMMON /BLOCK9/  DLTA                                             
00490       COMMON /BLOCK10/ MEANENE                                          
00500       COMMON /BLOCK12/ DR , RMX , CRAD, NRMX , NR0MX                    
00510       COMMON /BLOCK13/ R  , R0                                          
00520       COMMON /BLOCK14/ RADIAL , SUMRAD                                  
00530 C                                                                       
00540       INTEGER  NN , TT , SS , NNS                                       
00550       PARAMETER( NN=2050 , TT=600 , SS=200 )                            
00560       PARAMETER( NNS=100000 )                                           
00570       PARAMETER( NRANMX=500000   , PI=3.141592653589793D0 )             
00580 C                                                                       
00590       REAL*8   RX(NN) , RY(NN) , RZ(NN) , E(TT,NN) , ETOT(NN) 
00600       REAL*8   NDENS    , L                                             
00610       REAL     MEANENE(NNS)                                             
00620 C                                                                       
00630       INTEGER  ETMX(NN) , ETABLE(TT,NN) , N
00640 C                                                                       
00650       REAL     RAN(NRANMX)                                            
00660       INTEGER  NRAN , IX , NRANCHK                                    
00670 C                                                                       
00680       REAL*8   RXCAN , RYCAN  , RZCAN , RXIJ  , RYIJ  , RZIJ , RIJSQ
00690       REAL*8   EIJ   , ETOTCAN, ECAN(NN), RCOFF2 , L2 , C1   , C3   
00700 C                                                                       
00710       INTEGER  PNUM(NN), PMX                                            
00720       INTEGER  MCSMPL  , MCSMPL1 , MCSMPL2                              
00730       INTEGER  MCSMPLST, MCSMPLMX, SMPLSTEP                             
00740       INTEGER  NGRAPH1 , NOPT    , NP   , IC1  , ETMXMX    
00750 C                                                                       
00760       INTEGER  NRMX   , NR0MX  , NRADIAL, RADCOUNT  
00770       REAL*8   R0(SS) , R(SS)  , RADIAL(SS) , SUMRAD(SS) , R0CHKSQ 
00780 C                                                                       
00790                                                                   NP=9  
00800 C                                                                       
00810                OPEN(9, FILE='@AA1.DATA',STATUS='UNKNOWN',TYPE='TEXT')   
00820                OPEN(10,FILE='AA11.DATA',STATUS='UNKNOWN',TYPE='TEXT')   
00830                OPEN(11,FILE='AA21.DATA',STATUS='UNKNOWN',TYPE='TEXT')   
00840                OPEN(21,FILE='AA001.DATA',STATUS='UNKNOWN',TYPE='TEXT')  
00850                OPEN(22,FILE='AA011.DATA',STATUS='UNKNOWN',TYPE='TEXT')  
00860 C                                                                       
00870 C                                                --- PARAMETER (1) ---  
00880 C                              +  N=32,108,256,500,864,1372,2048,... +  
00890 C                              +  NDENS=0.1 , 0.65 , 1.2             +  
00900       N       =  256                                                    
00910       NDENS   =  0.65D0                                                 
00920       TEMP    =  1.2D0                                                  
00930       RCOFF   =  2.5D0                                                  
00940       DLTA    =  0.11D0                                                 
00950 C                                                --- PARAMETER (3) ---  
00960 C                                            +++ MCSMPLMX.GE.200 ! +++  
00970       MCSMPLST = 1                                                      
00980       MCSMPLMX = 100000                                                 
00990       NRADIAL  = 10000                                                  
01000 C                                                --- PARAMETER (4) ---  
01010       NGRAPH1  = 50000                                                  
01020       SMPLSTEP = 1                                                      
01030       NOPT     = 20                                                     
01040 C                                                --- PARAMETER (5) ---  
01050       NCHK    = 50                                                      
01060       NACCEPT = 0                                                       
01070 C                                                --- PARAMETER (6) ---  
01080       C0 =  ( 4.D0/NDENS )**(1./3.)                                     
01090       IQ  =  IDNINT( DBLE(N/4)**(1./3.) )                               
01100       L  =  C0*DBLE(IQ)                                                 
01110       IF( L .LE. 2.D0*RCOFF ) THEN                                      
01120         WRITE(NP,*) '****** N IS TOO SMALL.....'                        
01130         STOP                                                            
01140       END IF                                                            
01150       RCOFF2 = RCOFF**2                                                 
01160       L2 = L/2.D0                                                       
01170 C                                                --- PARAMETER (7) ---  
01180       IX = 0                                                            
01190       CALL RANCAL( NRANMX, IX, RAN )                                    
01200       NRAN    = 1                                                       
01210       NRANCHK = NRANMX - 5*N                                            
01220 C                                                --- PARAMETER (8) ---  
01230       DR      = 1.D0/DBLE( 20 )                                         
01240       RMX     = 5.D0                                                    
01250       CALL RADIALR( R0, R )                                             
01260       R0CHKSQ = R0(NR0MX)**2                                            
01270       CRAD   = ( L**3/DBLE(N**2) ) / ( 4.D0*PI*DR )                     
01280 C                                                                       
01290 C     ----------------------------------------------------------------  
01300 C     -----------------    INITIAL CONFIGURATION    ------------------  
01310 C     ----------------------------------------------------------------  
01320 C                                                                       
01330 C                                        --- SET INITIAL POSITIONS ---
01340 CCC   OPEN(19,FILE='AA091.DATA',STATUS='OLD',TYPE='TEXT')               
01350 CCC     READ(19,462)  N , L                                             
01360 CCC     READ(19,464) (RX(I),I=1,N) , (RY(I),I=1,N) , (RZ(I),I=1,N)      
01370 CCC   CLOSE(19,STATUS='KEEP')                                           
01380 CCC   GOTO 7                                                            
01390 C                                                                       
01400       CALL INIPOSIT( N , NDENS , L )                                    
01410 C                                             --- CALCULATE ENERGY --- 
01420     7 CALL ENECAL( N , RCOFF2 )                                         
01430 C                                                    --- PRINT OUT ---  
01440       WRITE(NP,12) N, NDENS, TEMP, L, RCOFF, DLTA                       
01450       WRITE(NP,14) MCSMPLMX, NGRAPH1                                    
01460       WRITE(NP,16) DR , RMX , NRMX                                      
01470 C                                                                       
01480 C                                               --- INITIALIZATION ---  
01490       ETMXMX   = 0                                                      
01500 C                                                                       
01510       RADCOUNT= 0                                                       
01520       DO 50 I=1,NRMX                                                    
01530         SUMRAD(I) = 0.D0                                                
01540    50 CONTINUE                                                          
01550 C                                                                       
01560 C     ----------------------------------------------------------------  
01570 C     ---------------    START OF MONTE CARLO PROGRAM    -------------  
01580 C     ----------------------------------------------------------------  
01590 C                                                                       
01600       MCSMPL1 =MCSMPLST                                             
01610       MCSMPL2 =MCSMPLMX                                             
01620 C                                                                       
01630       DO 500 MCSMPL = MCSMPL1 , MCSMPL2                                 
01640 C                                                                       
01650         DO 400 I=1,N                                                    
01660 C                                 ----------  (1) CANDIDATE  ---------  
01670 C                                                                       
01680 C                                                     +++ POSITION +++  
01690 C                                                                       
01700           RXCAN = RX(I) + DLTA*( 1.D0 - 2.D0*DBLE(RAN(NRAN)) )          
01710           NRAN  = NRAN + 1                                              
01720           RYCAN = RY(I) + DLTA*( 1.D0 - 2.D0*DBLE(RAN(NRAN)) )          
01730           NRAN  = NRAN + 1                                              
01740           RZCAN = RZ(I) + DLTA*( 1.D0 - 2.D0*DBLE(RAN(NRAN)) )          
01750           NRAN  = NRAN + 1                                              
01760           IF( RXCAN .GE. L    ) RXCAN = RXCAN - L                       
01770           IF( RXCAN .LT. 0.D0 ) RXCAN = RXCAN + L                       
01780           IF( RYCAN .GE. L    ) RYCAN = RYCAN - L                       
01790           IF( RYCAN .LT. 0.D0 ) RYCAN = RYCAN + L                       
01800           IF( RZCAN .GE. L    ) RZCAN = RZCAN - L                       
01810           IF( RZCAN .LT. 0.D0 ) RZCAN = RZCAN + L                       
01820 C                                                                       
01830 C                                -------  (2) CALCULATE ENERGY -------  
01840           PMX    = 0                                                    
01850           ETOTCAN= 0.D0                                                 
01860 C                                                       +++ ENERGY +++  
01870             DO 200 J=1,N                                                
01880 C                                                                       
01890               IF( J .EQ. I )               GOTO 200                     
01900 C                                                                       
01910               RXIJ = RX(J) - RXCAN                                      
01920               IF( RXIJ .GE.  L2 ) RXIJ = RXIJ - L                       
01930               IF( RXIJ .LT. -L2 ) RXIJ = RXIJ + L                       
01940               IF( DABS(RXIJ) .GE. RCOFF )  GOTO 200                     
01950               RYIJ = RY(J) - RYCAN                                      
01960               IF( RYIJ .GE.  L2 ) RYIJ = RYIJ - L                       
01970               IF( RYIJ .LT. -L2 ) RYIJ = RYIJ + L                       
01980               IF( DABS(RYIJ) .GE. RCOFF )  GOTO 200                     
01990               RZIJ = RZ(J) - RZCAN                                      
02000               IF( RZIJ .GE.  L2 ) RZIJ = RZIJ - L                       
02010               IF( RZIJ .LT. -L2 ) RZIJ = RZIJ + L                       
02020               IF( DABS(RZIJ) .GE. RCOFF )  GOTO 200                     
02030 C                                                                       
02040               RIJSQ = RXIJ**2 + RYIJ**2 + RZIJ**2                       
02050               IF( RIJSQ .GE. RCOFF2 )      GOTO 200                     
02060 C                                   ++++++++++++++++++++++++++++++++++
02070 C                                    PNUM(*):SAVE INTERACTIVE PARTICLE 
02080 C                                            NAMES.                   
02090 C                                    ECAN(*):SAVE INTERACTION ENERGIES
02100 C                                       *   :1,2,3,....,PMX           
02110 C                                   ++++++++++++++++++++++++++++++++++
02120 C                                                                       
02130               PMX = PMX + 1                                             
02140 C                                                                       
02150               SR2  = 1.D0/RIJSQ                                         
02160               SR6  = SR2*SR2*SR2                                        
02170               EIJ  = SR6*( SR6-1.D0 )                                   
02180 C                                                                       
02190               PNUM(PMX) = J                                             
02200               ECAN(PMX) = EIJ*4.D0                                      
02210               ETOTCAN   = ETOTCAN + EIJ                                 
02220 C                                                                       
02230   200       CONTINUE                                                    
02240 C                                                                       
02250             ETOTCAN = ETOTCAN*4.D0                                      
02260 C                                                                       
02270 C      --------  (3) JUDGEMENT ACCORDING TO METROPOLIS METHOD --------
02280 C                                                                       
02290             C3 = ETOTCAN - ETOT(I)                                      
02300             IF( C3 .GE. 0.D0 )THEN                                      
02310               IF( DBLE(RAN(NRAN)) .GE. DEXP(-C3/TEMP) )THEN             
02320                 NRAN = NRAN + 1                                         
02330                 GOTO 400                                                
02340               END IF                                                    
02350               NRAN = NRAN + 1                                           
02360             END IF                                                      
02370 C                                              +++++++++++++++++++++++  
02380 C                                              CANDIDATES ARE ACCEPTED  
02390 C                                              +++++++++++++++++++++++  
02400             NACCEPT = NACCEPT + 1                                       
02410 C                                                                       
02420 C                                     -------  (4) RENEW DATA  -------  
02430 C                                                                       
02440             RX(I)   = RXCAN                                             
02450             RY(I)   = RYCAN                                             
02460             RZ(I)   = RZCAN                                             
02470             ETOT(I) = ETOTCAN                                           
02480 C                                              ----- ENERGY DATA -----  
02490 C                                                                       
02500 C                                            +++++++++++++++++++++++++  
02510 C                                             FOR PARTICLES WHICH 
02520 C                                             INTERACT WITH PARTICLE I  
02530 C                                            +++++++++++++++++++++++++  
02540             IF ( PMX .EQ. 0 )       GOTO 365                            
02550 C                                                                       
02560             DO 360 JJ=1,PMX                                             
02570               J = PNUM(JJ)                                              
02580               IF( ETMX(J) .EQ. 0 )  GOTO 355                            
02590               DO 350 JJJ=1,ETMX(J)                                      
02600                 IF( ETABLE(JJJ,J) .EQ. I ) THEN                         
02610                   ETOT(J)  = ETOT(J) - E(JJJ,J) + ECAN(JJ)              
02620                   E(JJJ,J) = ECAN(JJ)                                   
02630                   GOTO 360                                              
02640                 END IF                                                  
02650   350         CONTINUE                                                  
02660   355         ETMX(J)  = ETMX(J) + 1                                    
02670               ETABLE(ETMX(J),J) = I                                     
02680               E(     ETMX(J),J) = ECAN(JJ)                              
02690               ETOT(J)  = ETOT(J) + ECAN(JJ)                             
02700   360       CONTINUE                                                    
02710 C                                       ++++++++++++++++++++++++++++++  
02720 C                                        FOR PARTICLES WHICH BECOME
02730 C                                        OUT OF RELATION TO PARTICLE I
02740 C                                       ++++++++++++++++++++++++++++++  
02750   365       IF( ETMX(I) .EQ. 0 )        GOTO 383                        
02760 C                                                                       
02770             DO 380 JJ=1,ETMX(I)                                         
02780               J = ETABLE(JJ,I)                                          
02790               IF( PMX .EQ. 0 )          GOTO 373                        
02800               DO 370 JJJ=1,PMX                                          
02810                 IF( PNUM(JJJ) .EQ. J )  GOTO 380                        
02820   370         CONTINUE                                                  
02830   373         IF( ETMX(J) .EQ. 0 )      GOTO 380                        
02840               IC1 = ETMX(J)                                             
02850               DO 375 JJJ=1,IC1                                          
02860                 IF( ETABLE(JJJ,J) .EQ. I ) THEN                         
02870                   ETOT(J)  = ETOT(J) - E(JJJ,J)                         
02880                   IF( JJJ .EQ. IC1 ) THEN                               
02890                     ETMX(J) = ETMX(J) - 1                               
02900                   ELSE                                                  
02910                     ETABLE(JJJ,J) = ETABLE(IC1,J)                       
02920                     E(     JJJ,J) = E(     IC1,J)                       
02930                     ETMX(J) = ETMX(J) - 1                               
02940                   END IF                                                
02950                   GOTO 380                                              
02960                 END IF                                                  
02970   375         CONTINUE                                                  
02980   380       CONTINUE                                                    
02990 C                                     ++++++++++++++++++++++++++++++++  
03000 C                                     RENEW DATA CONCERNING PARTICLE I
03010 C                                     ++++++++++++++++++++++++++++++++  
03020   383       ETMX(I) = PMX                                               
03030             IF( PMX .EQ. 0 )     GOTO 400                               
03040             DO 385 JJ=1,PMX                                             
03050               ETABLE(JJ,I) = PNUM(JJ)                                   
03060               E(JJ,I) = ECAN(JJ)                                        
03070   385       CONTINUE                                                    
03080 C                                                                       
03090 C                                                                       
03100   400     CONTINUE                                                      
03110 C                                                                       
03120 C                                         ----- ENERGY OF SYSTEM -----  
03130           C1 = 0.D0                                                     
03140           DO 450 J=1,N                                                  
03150             C1 = C1 + ETOT(J)                                           
03160   450     CONTINUE                                                      
03170           MEANENE(MCSMPL) = REAL(C1)/REAL(2*N)                          
03180 C                                                                       
03190 C                                      ----- RADIAL DISTRIBUTION -----  
03200           IF( MCSMPL .GT. NRADIAL ) THEN                                
03210             RADCOUNT = RADCOUNT + 1                                     
03220 C                                                 --- ALONG Z-AXIS ---  
03230             CALL RADIALCA( N, L, RADIAL, R0CHKSQ )                      
03240             DO 455 J=1,NRMX                                             
03250               SUMRAD(J) = SUMRAD(J) + RADIAL(J)                         
03260   455       CONTINUE                                                    
03270           END IF                                                        
03280 C                                 --- DATA OUTPUT FOR GRAPHICS (1) ---  
03290 C                                                                       
03300           IF( MOD(MCSMPL,NGRAPH1) .EQ. 0 ) THEN                         
03310             NOPT = NOPT + 1                                             
03320             WRITE(NOPT,462)  N , L                                      
03330             WRITE(NOPT,464) (RX(I),I=1,N),(RY(I),I=1,N),(RZ(I),I=1,N)   
03340           END IF                                                        
03350 C                                                                       
03360 C                                                                       
03370 C                                     --- CHECK OF MAXIMUM OF ETMX ---  
03380           DO 490 J=1,N                                                  
03390             IF( ETMX(J) .GT. ETMXMX ) ETMXMX = ETMX(J)                  
03400   490     CONTINUE                                                      
03410 C                                                                       
03420 C                           --- CHECK OF THE SUM OF RANDOM NUMBERS ---  
03430 C                                                                       
03440           IF( NRAN .GE. NRANCHK )THEN                                   
03450             CALL RANCAL( NRANMX, IX, RAN )                              
03460             NRAN = 1                                                    
03470           END IF                                                        
03480 C                               ----- ADJUST MAXIMUM DISPLACEMENT ----  
03490 C                                                                       
03500         IF( MOD(MCSMPL,NCHK) .EQ. 0 ) THEN                              
03510           RATIO = REAL(NACCEPT)/REAL(N*NCHK)                            
03520           IF( RATIO .GT. 0.5 ) THEN                                     
03530             DLTA = DLTA*1.05D0                                          
03540           ELSE                                                          
03550             DLTA = DLTA*0.95D0                                          
03560           END IF                                                        
03570           NACCEPT = 0                                                   
03580         END IF                                                          
03590 C                                                                       
03600 C                                                                       
03610 C                                                                       
03620   500 CONTINUE                                                        
03630 C                                                                       
03640 C     ----------------------------------------------------------------  
03650 C     -----------------  END OF MONTE CARLO PROGRAM  -----------------  
03660 C     ----------------------------------------------------------------  
03670 C                                                                       
03680 C                                            --- PRINT OUT RESULTS ---
03690        CALL PRNTDATA( MCSMPL1 , MCSMPL2 , NP )                         
03700        WRITE(NP,612)  ETMXMX , MCSMPL1 , MCSMPL2                       
03710 C
03720 C                                 --- DATA OUTPUT FOR GRAPHICS (2) ---  
03730       IC = 0                                                            
03740       WRITE(10,1012) N, IC, NDENS, TEMP, RCOFF, L                       
03750       WRITE(10,1013) DLTA, MCSMPLMX, SMPLSTEP                           
03760       WRITE(10,1014) ( MEANENE(I),I=SMPLSTEP,MCSMPLMX,SMPLSTEP )        
03770 C                                                                       
03780 C                                 --- DATA OUTPUT FOR GRAPHICS (3) ---  
03790       DO 1100 I=1,NRMX                                                  
03800         RADIAL(I) = SUMRAD(I)/DBLE(RADCOUNT)                            
03810  1100 CONTINUE                                                          
03820       WRITE(11,1102) NRMX , RADCOUNT                                    
03830       DO 1105 I=1,NRMX                                                  
03840         WRITE(11,1104) I, R(I), RADIAL(I)                               
03850  1105 CONTINUE                                                          
03860 C                                                                       
03870 C                                             --- PRINT OUT R.D.F. ---  
03880       WRITE(NP,1106) RADCOUNT                                           
03890       DO 1110 I=1,NRMX                                                  
03900         WRITE(NP,1108) I , R(I) , RADIAL(I)                             
03910  1110 CONTINUE                                                          
03920                                            CLOSE(9, STATUS='KEEP')      
03930                                            CLOSE(10,STATUS='KEEP')      
03940                                            CLOSE(11,STATUS='KEEP')      
03950                                            CLOSE(21,STATUS='KEEP')      
03960                                            CLOSE(22,STATUS='KEEP')      
03970 C     -------------------------- FORMAT ------------------------------  
03980    12 FORMAT(/1H ,'--------------------------------------------------'  
03990      &       /1H ,'-              MONTE CARLO METHOD                -'  
04000      &       /1H ,'--------------------------------------------------'  
04010      &      //1H ,'N=',I4, 3X ,'NDENS=',F5.2, 2X ,'TEMP=',F5.2, 2X ,    
04020      &            'L=',F6.2                                             
04030      &       /1H ,'RCOFF=',F6.2, 2X ,'DLTA=',F7.4)                      
04040    14 FORMAT(/1H ,'MCSMPLMX=',I8, 2X ,'NGRAPH1=',I8)                    
04050    16 FORMAT(/1H ,'DR=',F6.3, 3X ,'RMX=',F6.3, 3X ,'NRMX=',I4/)         
04060   462 FORMAT( I4 , F9.4 )                                               
04070   464 FORMAT( (8F10.5) )                                                
04080   612 FORMAT(///1H ,18X, 'MAXIMUM OF ETMX=',I7                          
04090      &         /1H ,18X, 'START OF MC SAMPLING STEP=',I7                
04100      &         /1H ,18X, 'END   OF MC SAMPLING STEP=',I7/)              
04110  1012 FORMAT( I7 , I3 , 4F8.4 )                                         
04120  1013 FORMAT( F8.4 , 2I8 )                                              
04130  1014 FORMAT( (5E16.9) )                                                
04140  1102 FORMAT( 2I8 )                                                     
04150  1104 FORMAT( I6 , F8.4 , F10.5 )                                       
04160  1106 FORMAT(///1H ,'------ RADIAL DISTRIBUTION ------'                 
04170      &         /1H ,'       SAMPLING NUMBER=',I7/)                      
04180  1108 FORMAT(1H ,'NR=',I4, 3X ,'R=',F6.3, 3X , 'R.D.F.=',F9.4)        
04190       STOP  
04200       END   
04210 C*********************************************************************  
04220 C***************************   SUBROUTINE   **************************  
04230 C*********************************************************************  
04240 C                                                                       
04250 C**** SUB PRNTDATA ****                                                 
04260       SUBROUTINE PRNTDATA( MCSST, MCSMX, NP )                           
04270 C                                                                       
04280       COMMON /BLOCK10/ MEANENE                                          
04290 C                                                                       
04300       PARAMETER( NNS=100000 )                                           
04310 C                                                                       
04320       INTEGER  MCSST     , MCSMX     , NP                               
04330       REAL     MEANENE(NNS)                                             
04340 C                                                                       
04350       REAL     AMEANENE(10) , C0                                        
04360       INTEGER  IC , IMC(0:10) , JS , JE                                 
04370 C                                                                       
04380 C                                  --- PRINT OUT PROCESS OF ENERGY ---
04390       IC = ( MCSMX-MCSST+1 )/50                                         
04400       DO 20 I= MCSST-1+IC , MCSMX , IC                                  
04410         WRITE(NP,10) I , MEANENE(I)                                     
04420    20 CONTINUE                                                          
04430 C                                     --- MONTE CARLO STEP AVERAGE ---  
04440       IC = ( MCSMX-MCSST+1 )/10                                         
04450       DO 30 I=0,10                                                      
04460         IMC(I) = MCSST - 1 + IC*I                                       
04470         IF( I .EQ. 10 ) IMC(I) =MCSMX                                   
04480    30 CONTINUE                                                          
04490 C                                                                       
04500 C                                                                       
04510       DO 35 I=1,10                                                      
04520         AMEANENE(I) = 0.                                                
04530    35 CONTINUE                                                          
04540 C                                                                       
04550       DO 50 I=1,10                                                      
04560         JS = IMC(I-1) + 1                                               
04570         JE = IMC(I)                                                     
04580         DO 40 J=JS,JE                                                   
04590           AMEANENE(I) = AMEANENE(I) + MEANENE(J)                        
04600    40   CONTINUE                                                        
04610    50 CONTINUE                                                          
04620 C                                                                       
04630       DO 70 I=1,10                                                      
04640         C0          = REAL( IMC(I)-IMC(I-1) )                           
04650         AMEANENE(I) = AMEANENE(I)/C0                                    
04660    70 CONTINUE                                                          
04670 C                                        --- PRINT OUT MEAN ENERGY ---  
04680       WRITE(NP,75)                                                      
04690       DO 90 I=1,10                                                      
04700        WRITE(NP,80)I,IMC(I-1)+1,IMC(I), AMEANENE(I)                     
04710    90 CONTINUE                                                          
04720 C     ----------------------------------------------------------------  
04730    10 FORMAT(1H ,'MCSMPL=',I5, 3X ,'MEAN ENERGY=',E12.5)                
04740    75 FORMAT(//1H ,'-----------------------------------------------'    
04750      &        /1H ,'             MONTE CARLO AVERAGE               '    
04760      &        /)                                                        
04770    80 FORMAT(1H ,'I=',I2, 2X ,'SMPLMN=',I5, 2X ,'SMPLMX=',I5, 2X,       
04780      &           'MEAN ENERGY=',E12.5/)                                 
04790                                                                 RETURN  
04800                                                                 END     
04810 C**** RADIALR ****                                                      
04820       SUBROUTINE RADIALR( R0, R )                                       
04830 C                                                                       
04840       IMPLICIT REAL*8 (A-H,O-Z)                                         
04850 C                                                                       
04860       INTEGER  SS                                                       
04870       PARAMETER( SS=200 )                                               
04880 C                                                                       
04890       COMMON /BLOCK12/ DR , RMX , CRAD , NRMX ,NR0MX                    
04900 C                                                                       
04910       INTEGER  NRMX   , NR0MX                                           
04920       REAL*8   R0(SS) , R(SS) , C0 , C1                                 
04930 C                                                                       
04940       C0    = DR/2.D0                                                   
04950 C                                               --- CALCULATE R(*) ---  
04960       R0(1) = 0.8D0                                                     
04970       R(1)  = R0(1) + C0                                                
04980 C                                                                       
04990       DO 50 I=2,210                                                     
05000         R0(I) = R0(1) + DBLE(I-1)*DR                                    
05010         C1     = R0(I) + C0                                             
05020         IF( C1.GT.RMX )THEN                                             
05030           NR0MX = I                                                     
05040           NRMX  = I-1                                                   
05050           GOTO 60                                                       
05060         END IF                                                          
05070         R(I) = C1                                                       
05080    50 CONTINUE                                                          
05090    60                                                          RETURN   
05100                                                                END      
05110 C**** RADIALCA ****                                                     
05120       SUBROUTINE RADIALCA( N, L, RADIAL, R0CHKSQ )                      
05130 C                                                                       
05140       IMPLICIT REAL*8 (A-H,O-Z)                                         
05150 C                                                                       
05160       COMMON /BLOCK1/  RX  , RY  , RZ                                   
05170       COMMON /BLOCK12/ DR  , RMX , CRAD, NRMX , NR0MX                   
05180       COMMON /BLOCK13/ R   , R0                                         
05190 C                                                                       
05200       INTEGER  NN , TT , SS                                             
05210       PARAMETER( NN=2050 , TT=600 , SS=200 )                            
05220 C                                                                       
05230       INTEGER  N                                                        
05240       REAL*8   RX(NN) , RY(NN) , RZ(NN) , L                             
05250       REAL*8   RXIJ   , RYIJ   , RZIJ   , RIJ , RIJSQ                   
05260 C                                                                       
05270       INTEGER  NR0   , NRMX   , NR0MX                                   
05280       REAL*8   R(SS) , R0(SS) , RADIAL(SS) , L2 
05290 C                                                                       
05300       L2 = L/2.D0                                                       
05310       DO 10 I=1,NRMX                                                    
05320         RADIAL(I) = 0.D0                                                
05330    10 CONTINUE                                                          
05340 C                                 --- CALCULATE RADIAL DIST. FUNC. ---
05350       DO 200 I=1,N                                                      
05360 C                                                                       
05370 C                                                                       
05380             DO 140 J=1,N                                                
05390               IF( J .EQ. I ) GOTO 140                                   
05400 C                                                                       
05410               RXIJ = RX(J) - RX(I)                                      
05420               IF( RXIJ .GE.  L2 ) RXIJ = RXIJ - L                       
05430               IF( RXIJ .LT. -L2 ) RXIJ = RXIJ + L                       
05440               RYIJ = RY(J) - RY(I)                                      
05450               IF( RYIJ .GE.  L2 ) RYIJ = RYIJ - L                       
05460               IF( RYIJ .LT. -L2 ) RYIJ = RYIJ + L                       
05470               RZIJ = RZ(J) - RZ(I)                                      
05480               IF( RZIJ .GE.  L2 ) RZIJ = RZIJ - L                       
05490               IF( RZIJ .LT. -L2 ) RZIJ = RZIJ + L                       
05500 C                                                                       
05510               RIJSQ= RXIJ**2 + RYIJ**2 + RZIJ**2                        
05520 C                                      +++ OVER CHECK AREA(RADIAL) +++  
05530               IF( RIJSQ .GE. R0CHKSQ ) GOTO 140                         
05540               RIJ = DSQRT(RIJSQ)                                        
05550 C                                                                       
05560               DO 130  NR0=2,NR0MX                                       
05570                 IF( R0(NR0).GT.RIJ ) THEN                               
05580                   RADIAL(NR0-1) = RADIAL(NR0-1) + 1.D0                  
05590                   GOTO 140                                              
05600                 END IF                                                  
05610   130         CONTINUE                                                  
05620 C                                                                       
05630   140       CONTINUE                                                    
05640 C                                                                       
05650 C                                                                       
05660   200 CONTINUE                                                          
05670 C                             --- DIVIDE THE DATA BY SMALL VOLUME ---
05680       DO 210 I=1,NRMX                                                   
05690         RADIAL(I) = CRAD * RADIAL(I)/R(I)**2                            
05700   210 CONTINUE                                                          
05710       RETURN   
05720       END      
